#-----------------------------------------------------------------------------
# Following Jan's model.
# 7/2/07, by Ockham
from Tkinter import *
import tkFileDialog
import poser
import os
scene = poser.Scene()

#-----------------------------------------------------------------------------
'''
{
 version
 {
  number 4.01
 }
 actor $CURRENT
 {
  channels
  {
  scale scale
   {
   keys
    {
    k 0 1
    }
   }
  scaleX xScale
   {
   keys
    {
    k 0 1
    }
   }
  scaleY yScale
   {
   keys
    {
    k 0 1
    }
   }
  scaleZ zScale
   {
   keys
    {
    k 0 1
    }
   }
   rotateX xRotate
   {
    keys
    {
     k 0  0
    }
   }
   rotateY yRotate
   {
    keys
    {
     k 0  0
    }
   }
   rotateZ zRotate
   {
    keys
    {
     k 0  0
    }
   }
   translateX xTran
   {
    keys
    {
     k 0  0
    }
   }
   translateY yTran
   {
    keys
    {
     k 0  0
    }
   }
   translateZ zTran
   {
    keys
    {
     k 0  0
    }

   }
  }
 }
 figure
 {
 }
}

'''

TopHead='{\n version\n {\n number 4.01\n }\nclearFigureKeys %d\n actor $CURRENT\n {\n channels\n {\n'
KeyHead='   {\n'
KeyMain='   k %d %f\n'
KeyTail='   }\n'

scaleAhead=    'scale scale\n {\n keys\n'
scaleXhead=    ' }\n scaleX xScale\n {\n keys\n'
scaleYhead=    ' }\n scaleY yScale\n {\n keys\n'
scaleZhead=    ' }\n scaleZ zScale\n {\n keys\n'
rotateXhead=   ' }\n rotateX xRotate\n {\n keys\n'
rotateYhead=   ' }\n rotateY yRotate\n {\n keys\n'
translateXhead=' }\n translateX xTran\n {\n keys\n'
translateYhead=' }\n translateY yTran\n {\n keys\n'
translateZhead=' }\n translateZ zTran\n {\n keys\n'
BotHead=       ' }\n }\n figure\n {\n }\n }\n'

A=scene.CurrentActor()

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Fit Pose")

        self.StatusEntry = Entry(self.master,width=50)
        self.StatusEntry.grid(row=0,column=0,columnspan=2)
        self.StatusEntry.insert(0,"%s is selected" % A.Name())

        # Go/nogo buttons.
        self.buttonGo = Button(self.master, text="Name file", command=self.HandleGo)
        self.buttonGo.grid(row=3, column=0)

        self.buttonCancel = Button(self.master, text="Cancel", command=self.HandleCancel)
        self.buttonCancel.grid(row=3, column=2)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


    # - - - - - - - - - - - - - - - - - -

    def ShowStatus(self,S): # Just saving repetition
        self.StatusEntry.delete(0,END)
        self.StatusEntry.insert(0,S)
        self.StatusEntry.update_idletasks()

    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents()
        root.lift()
        root.after(100, self.Update)

    # - - - - - - - - - - - - - - - - - -

    def HandleName(self):
        # Pop up file box to get name.
        BasePathUncut=poser.AppLocation()
        BasePath=BasePathUncut[:(-len('poser.exe'))]
        MyPath=os.path.normpath(os.path.join(BasePath,'runtime','libraries','pose','*.PZ2'))
        fn=tkFileDialog.asksaveasfilename(initialfile=MyPath, defaultextension=[("PZ2 file", "*.PZ2 *.pz2")] )

        if not fn:
            self.ShowStatus("No file selected. Try again.")
            return 0

        return os.path.abspath(fn)

    # - - - - - - - - - - - - - - - - - -

    def HandleGo(self):
        fn=self.HandleName() # Get filename
        # Open file
        fp=open(fn,'wt')

        frames=scene.NumFrames()
        # Write header
        fp.write(TopHead % frames)

        # Write a paragraph for each parm

        fp.write(scaleAhead)
        fp.write(KeyHead)
        for f in range(frames):
            scene.SetFrame(f)
            v=A.ParameterByCode(poser.kParmCodeASCALE).Value()
            fp.write(KeyMain % (f,v))
        fp.write(KeyTail)

        fp.write(scaleXhead)
        fp.write(KeyHead)
        for f in range(frames):
            scene.SetFrame(f)
            v=A.ParameterByCode(poser.kParmCodeXSCALE).Value()
            fp.write(KeyMain % (f,v))
        fp.write(KeyTail)

        fp.write(scaleYhead)
        fp.write(KeyHead)
        for f in range(frames):
            scene.SetFrame(f)
            v=A.ParameterByCode(poser.kParmCodeYSCALE).Value()
            fp.write(KeyMain % (f,v))
        fp.write(KeyTail)

        fp.write(scaleZhead)
        fp.write(KeyHead)
        for f in range(frames):
            scene.SetFrame(f)
            v=A.ParameterByCode(poser.kParmCodeZSCALE).Value()
            fp.write(KeyMain % (f,v))
        fp.write(KeyTail)

        fp.write(rotateXhead)
        fp.write(KeyHead)
        for f in range(frames):
            scene.SetFrame(f)
            v=A.ParameterByCode(poser.kParmCodeXROT).Value()
            fp.write(KeyMain % (f,v))
        fp.write(KeyTail)

        fp.write(rotateYhead)
        fp.write(KeyHead)
        for f in range(frames):
            scene.SetFrame(f)
            v=A.ParameterByCode(poser.kParmCodeYROT).Value()
            fp.write(KeyMain % (f,v))
        fp.write(KeyTail)

        fp.write(translateXhead)
        fp.write(KeyHead)
        for f in range(frames):
            scene.SetFrame(f)
            v=A.ParameterByCode(poser.kParmCodeXTRAN).Value()
            fp.write(KeyMain % (f,v))
        fp.write(KeyTail)

        fp.write(translateYhead)
        fp.write(KeyHead)
        for f in range(frames):
            scene.SetFrame(f)
            v=A.ParameterByCode(poser.kParmCodeYTRAN).Value()
            fp.write(KeyMain % (f,v))
        fp.write(KeyTail)

        fp.write(translateZhead)
        fp.write(KeyHead)
        for f in range(frames):
            scene.SetFrame(f)
            v=A.ParameterByCode(poser.kParmCodeZTRAN).Value()
            fp.write(KeyMain % (f,v))
        fp.write(KeyTail)

        fp.write(BotHead)
        fp.close()
        self.ShowStatus("Done writing.")

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
